package test;

import com.sun.star.beans.PropertyValue;
import com.sun.star.container.XNameAccess;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.frame.XController;
import com.sun.star.frame.XModel;
import com.sun.star.frame.XStorable;
import com.sun.star.lang.XComponent;
import com.sun.star.sheet.*;
import com.sun.star.table.CellRangeAddress;
import com.sun.star.table.XCellRange;
import com.sun.star.uno.Any;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.view.XSelectionSupplier;
import net.sf.jooreports.converter.DocumentConverter;
import net.sf.jooreports.converter.DocumentFormat;
import net.sf.jooreports.converter.XmlDocumentFormatRegistry;
import net.sf.jooreports.openoffice.connection.OpenOfficeConnection;
import net.sf.jooreports.openoffice.connection.SocketOpenOfficeConnection;
import net.sf.jooreports.openoffice.converter.OpenOfficeDocumentConverter;

import java.io.File;

/**
 * Created by IntelliJ IDEA.
 * User: schernolyas
 * Date: Jan 23, 2007
 * Time: 6:16:23 PM
 * To change this template use File | Settings | File Templates.
 */
public class ExcelWork {


    public static void main(String[] argv) {
        try {
            // connect to an OpenOffice.org instance running on port 8100
            OpenOfficeConnection connection = new SocketOpenOfficeConnection(8100);
            connection.connect();

            XComponentLoader xCompLoader = (XComponentLoader)
                    UnoRuntime.queryInterface(com.sun.star.frame.XComponentLoader.class, connection.getDesktop());

            PropertyValue[] myProperties = new PropertyValue[1];
            myProperties[0] = new PropertyValue();
            myProperties[0].Name = "Hidden";
            // for open document and do not show user interface use "true"
            myProperties[0].Value = Boolean.TRUE;

            String sUrl = "file:///c:/work/JOOConverter/Book1.xls";

            XComponent xComponent = xCompLoader.loadComponentFromURL(sUrl, "_blank", 0, myProperties);

            XSpreadsheetDocument xSpreadsheetDocument = (XSpreadsheetDocument)
                    UnoRuntime.queryInterface(XSpreadsheetDocument.class, xComponent);

            XSpreadsheets xSheets = xSpreadsheetDocument.getSheets();


            String mainPage = "1pager";
            XNameAccess xSheetsNA = (com.sun.star.container.XNameAccess)
                    UnoRuntime.queryInterface(com.sun.star.container.XNameAccess.class, xSheets);
            Any any = (Any) xSheetsNA.getByName(mainPage);

            // for the controller: first query the XModel interface from our spreadsheet component
            XModel xSpreadsheetModel = (XModel) UnoRuntime.queryInterface(XModel.class, xComponent);
            // then get the current controller from the model
            XController xSpreadsheetController = xSpreadsheetModel.getCurrentController();

            // get the XSpreadsheetView interface from the controller, we want to call its method
            // setActiveSheet
            XSpreadsheetView xSpreadsheetView = (XSpreadsheetView) UnoRuntime.queryInterface(
                    XSpreadsheetView.class, xSpreadsheetController);

            // make our newly inserted sheet the active sheet using setActiveSheet
            xSpreadsheetView.setActiveSheet((XSpreadsheet) any.getObject());

            XPrintAreas printArea = (XPrintAreas) UnoRuntime.queryInterface(XPrintAreas.class, xSpreadsheetView.getActiveSheet());

            CellRangeAddress[] addresses = printArea.getPrintAreas();
            System.err.println("addresses.length :" + addresses.length);

            if (addresses.length == 1) {
                System.err.println("StartColumn :" + addresses[0].StartColumn);
                System.err.println("StartRow :" + addresses[0].StartRow);
                System.err.println("EndColumn :" + addresses[0].EndColumn);
                System.err.println("EndRow :" + addresses[0].EndRow);
                printArea.setPrintAreas(addresses);
            }

            // save updates

            String storeUrl = "file:///c:/work/JOOConverter/Book2.xls";

            XStorable xStorable = (XStorable) UnoRuntime.queryInterface(XStorable.class, xSpreadsheetDocument);

            if (xStorable != null) {
                PropertyValue[] storeProps = new PropertyValue[3];
                storeProps[0] = new PropertyValue();
                storeProps[0].Name = "FilterName";
                storeProps[0].Value = "MS Excel 97";
                //storeProps[0].Value = "calc_pdf_Export";
                storeProps[1] = new PropertyValue();
                storeProps[1].Name = "Overwrite";
                storeProps[1].Value = Boolean.TRUE;
                storeProps[2] = new PropertyValue();


                PropertyValue[] filterProps = new PropertyValue[1];
                filterProps[0] = new PropertyValue();
                filterProps[0].Name = "PageRages";
                filterProps[0].Value = "1-2";

                storeProps[2].Name = "FilterData";
                storeProps[2].Value = filterProps;

                xStorable.storeAsURL(storeUrl, storeProps);
            } else {
                System.err.println("fuck!");

            }
            XmlDocumentFormatRegistry registry = new XmlDocumentFormatRegistry();

            DocumentFormat format = registry.getFormatByFileExtension("pdf");

            //format.setExportOption("SelectionOnly", Boolean.TRUE);
            format.setExportOption("Overwrite", Boolean.TRUE);
            format.setExportOption("UseTaggedPDF", Boolean.TRUE);
            format.setExportOption("ExportNotes", Boolean.TRUE);
            format.setExportOption("PageRages", "1,2");


            DocumentConverter converter = new OpenOfficeDocumentConverter(connection);
            converter.convert(new File("c:\\work\\JOOConverter\\Book2.xls"),
                    new File("c:\\work\\JOOConverter\\Book1.pdf"), format);


            xComponent.dispose();
            connection.disconnect();


        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
